<template>
  <div class="h-auto w-full">
    <div v-show="!slideScrollStart" class="rounded-full cursor-pointer flex absolute z-10 left-0 mt-40 -ml-6 bg-gray-200 justify-center items-center bg-opacity-50 w-12 h-12 hover:bg-opacity-100" @click="changeSlide(-1)">
      <svg fill="currentColor" class="fill-current text-indigo-700 inline-block h-5 w-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 11 18">
        <path transform="rotate(90) translate(0, -11)" d="M2.1 0L0 2.1 9 11l9-8.9L15.9 0 9 6.8 2.1 0z"></path>
      </svg>
    </div>
    <div v-show="!slideScrollEnd" class="rounded-full cursor-pointer flex absolute z-10 right-0 -mr-6 mt-40 bg-gray-200 justify-center items-center bg-opacity-50 w-12 h-12 hover:bg-opacity-100" @click="changeSlide(1)">
      <svg fill="currentColor" class="fill-current text-indigo-700 inline-block h-5 w-5" viewBox="0 0 11 18">
        <path transform="rotate(-90) translate(-18, 0)" d="M2.1 0L0 2.1 9 11l9-8.9L15.9 0 9 6.8 2.1 0z"></path>
        </svg>
    </div>
    <ul class="featured-products-slide py-2">
      <li
        v-for="(product, index) in products"
        :key="index"
        :index="index"
        class="item shadow-lg"
      >
      <nuxt-link :to="localePath({ name: 'products-slug', params: { slug: product.slug } })">
        <div class="relative flex flex-col h-auto px-6 w-full justify-center">
          <div class="absolute top-0 right-0 m-4 rounded-full bg-gray-400 p-1">
            <a href="">
              <svg fill="currentColor" class="fill-current text-indigo-700 inline-block h-6 w-6" version="1.1" viewBox="0 0 512 512" xml:space="preserve" stroke="#727272" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink"><path d="M340.8,98.4c50.7,0,91.9,41.3,91.9,92.3c0,26.2-10.9,49.8-28.3,66.6L256,407.1L105,254.6c-15.8-16.6-25.6-39.1-25.6-63.9  c0-51,41.1-92.3,91.9-92.3c38.2,0,70.9,23.4,84.8,56.8C269.8,121.9,302.6,98.4,340.8,98.4 M340.8,83C307,83,276,98.8,256,124.8  c-20-26-51-41.8-84.8-41.8C112.1,83,64,131.3,64,190.7c0,27.9,10.6,54.4,29.9,74.6L245.1,418l10.9,11l10.9-11l148.3-149.8  c21-20.3,32.8-47.9,32.8-77.5C448,131.3,399.9,83,340.8,83L340.8,83z" stroke="#727272"/></svg>
            </a>
          </div>
          <div class="flex w-full justify-center"><img :src="require('~/assets/img/feature2.png')" alt=""></div>
          <div class="">
            <div><p class="whitespace-normal text-gray-700 font-light text-sm h-10 overflow-hidden max-w-xs break-words">{{ product.name }}</p></div>
            <div class="my-4"><StarRating class="w-20" :rating="rating" :star-style="ratingStyle" :isIndicatorActive="false" /></div>
            <div class="text-gray-700 font-bold text-lg">{{ product.price }}</div>
            <div class="text-gray-700 font-light text-sm">12x de xxx s/juros</div>
            <!-- <div class="lg:container lg:mx-auto w-full items-center my-4"><nuxt-link :to="localePath({ name: 'products-slug', params: { slug: product.slug } })" class="bg-indigo-700 text-center text-sm px-6 py-2 hover:bg-indigo-500 text-white font-semibold transition-all duration-500 ease">eu quero</nuxt-link></div> -->
          </div>
        </div>
        </nuxt-link>
      </li>
    </ul>
  </div>
</template>

<script>
// import Carousel from './Carousel'
// import CarouselSlide from './CarouselSlide'
import StarRating from '@/components/StarRating'

export default {
  props: ['products'],
  components: {
    // Carousel,
    // CarouselSlide,
    StarRating
  },

  data() {
    return {

      rating: Math.random() * 5,
      ratingStyle: {
          fullStarColor: '#ed8a19',
          emptyStarColor: '#ccc',
          starWidth: 20,
          starHeight: 20
      },
      slideElement: null,
      slideScrollEnd: false,
      slideScrollStart: false,
      interval: 0
    }
  },

  methods: {
    changeSlide(delta) {
      // const carousel = document.querySelector(".carousel")
      const width = this.slideElement.offsetWidth
      if (delta === -1 && this.slideElement.scrollLeft === 0) {
        this.slideElement.scrollTo({ left: this.slideElement.scrollWidth, top: 0, behavior: 'smooth' })
      } else if (delta === 1 && parseInt(this.slideElement.scrollWidth - this.slideElement.offsetWidth) === parseInt(this.slideElement.scrollLeft)){
        this.slideElement.scrollTo({ left: 0, top: 0, behavior: 'smooth' })
      } else {
        this.slideElement.scrollTo({ left: this.slideElement.scrollLeft + width * delta, top: 0, behavior: 'smooth' })
      }
    },
  },

  mounted() {
    this.slideElement = document.querySelector('.featured-products-slide')

    this.interval = setInterval(() => {
      this.slideScrollEnd = parseInt(this.slideElement.scrollWidth - this.slideElement.offsetWidth) === parseInt(this.slideElement.scrollLeft)
      this.slideScrollStart = parseInt(this.slideElement.scrollLeft) === 0
    }, 100);
  },

  destroyed() {
    clearInterval(this.interval)
  }
}
</script>

<style lang="scss" scoped>
:root {
  --gutter: 20px;
}

body {
  overflow: hidden;
}

@media screen and (max-width: 767px){
  .featured-products-slide {
    display: grid;
    grid-column-gap: 1rem;
    /* width: 102%; */
    margin: 0;
    /* grid-template-columns: 20px;
    grid-template-rows: minmax(226px, 1fr); */
    grid-auto-flow: column;
    grid-auto-columns: calc(50% - var(--gutter) * 2);
    height: 25rem;
    justify-content: start;
    overflow-x: scroll;
    scroll-snap-type: x mandatory;
    margin-bottom: 2rem;
    // padding-bottom: calc( .75 * var(--gutter));
    // margin-bottom: calc( -.25 * var(--gutter));
  }


  .featured-products-slide > li.item {
    scroll-snap-align: start;
    flex: 0 1 100%;
    padding: calc(var(--gutter) / 2);
    display: flex;
    flex-direction: column;
    /* justify-content: center; */
    align-items: center;
    background: #fff;
    margin: 0;
    /* border-radius: 8px; */
    width: 13.2rem;
    /* box-shadow: rgba(0, 0, 0, 0.2) 0px 2px 6px; */
  }
}
  .featured-products-slide {
    display: grid;
    grid-column-gap: 1.2rem;
    /* width: 102%; */
    margin: 0;
    /* grid-template-columns: 20px;
    grid-template-rows: minmax(226px, 1fr); */
    grid-auto-flow: column;
    grid-auto-columns: calc(50% - var(--gutter) * 2);
    height: 25rem;
    justify-content: start;
    overflow-x: scroll;
    scroll-snap-type: x mandatory;
    margin-bottom: 2rem;
    // padding-bottom: calc( .75 * var(--gutter));
    // margin-bottom: calc( -.25 * var(--gutter));
  }


  .featured-products-slide > .item {
    scroll-snap-align: start;
    flex: 0 1 100%;
    padding: calc(var(--gutter) / 2);
    display: flex;
    flex-direction: column;
    /* justify-content: center; */
    align-items: center;
    background: #fff;
    margin: 0;
    /* border-radius: 8px; */
    width: 14.1rem;
    /* box-shadow: rgba(0, 0, 0, 0.2) 0px 2px 6px; */
  }

  .featured-products-slide::-webkit-scrollbar {
    display: none;
  }

</style>
